## ros-kinetic-industrial-robot-client 0.7.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

project(industrial_robot_client)

find_package(catkin REQUIRED COMPONENTS roscpp std_msgs sensor_msgs 
  control_msgs trajectory_msgs simple_message actionlib_msgs actionlib 
  urdf industrial_msgs industrial_utils)

find_package(Boost REQUIRED COMPONENTS system thread)

# The definition is copied from the CMakeList for the simple_message package.
add_definitions(-DROS=1)           #build using ROS libraries
add_definitions(-DLINUXSOCKETS=1)  #build using LINUX SOCKETS libraries

set(SRC_FILES src/joint_relay_handler.cpp
              src/robot_status_relay_handler.cpp
              src/joint_trajectory_downloader.cpp
              src/joint_trajectory_streamer.cpp
              src/joint_trajectory_interface.cpp
              src/robot_state_interface.cpp
              src/utils.cpp)

# NOTE: The libraries generated this package are not included in the catkin_package
# macro because libraries must be explicitly linked in projects that depend on this
# package.  If this is not done (and these libraries were exported), then multiple
# library definitions (normal - industrial_robot_client and byteswapped.
# industrial_robot_client_bswap) are both included (this is bad).
catkin_package(
    CATKIN_DEPENDS roscpp std_msgs sensor_msgs control_msgs trajectory_msgs
      simple_message actionlib_msgs actionlib urdf industrial_msgs
      industrial_utils
    INCLUDE_DIRS include
    LIBRARIES ${PROJECT_NAME}_dummy
    CFG_EXTRAS issue46_workaround.cmake
)



include_directories(include
  ${catkin_INCLUDE_DIRS}
)


# generate dummy library (we export it in catkin_package(..)), to force catkin
# to set up LIBRARY_DIRS properly.
# TODO: find out if LIBRARY_DIRS can be exported without dummy library target
add_custom_command(
  OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}_dummy.cpp
  COMMAND ${CMAKE_COMMAND} -E touch ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}_dummy.cpp)
add_library(${PROJECT_NAME}_dummy ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}_dummy.cpp)
# unfortunately this will have to be installed, but the linker will remove it
# from the library dependencies of dependent targets, as it contains no symbols
# that can be imported from it.
install(TARGETS ${PROJECT_NAME}_dummy DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION})


# This library depends on the simple_message library, which is available
# in two formats to support endian differences between robot & PC.
#
# As in simple_message, two libraries are created: one that does direct
# passthrough of binary numeric data to the robot controller, and one that
# uses byte-swapping to account for endian mis-matches.
#
# Due to catkin dependency limitations, higher-level code must
# explicitly link to the desired industrial_robot_client library:
#    target_link_libraries(my_node industrial_robot_client)
#      or
#    target_link_libraries(my_node industrial_robot_client_bswap)
#

add_library(industrial_robot_client ${SRC_FILES})
target_link_libraries(industrial_robot_client simple_message)

add_library(industrial_robot_client_bswap ${SRC_FILES})
target_link_libraries(industrial_robot_client_bswap simple_message_bswap)

# The following executables(nodes) are for applications where the robot
# controller and pc have the same byte order (i.e. byte swapping NOT
# required)

add_executable(robot_state
  src/generic_robot_state_node.cpp)
target_link_libraries(robot_state 
  industrial_robot_client
  simple_message
  ${catkin_LIBRARIES})

add_executable(motion_streaming_interface
  src/generic_joint_streamer_node.cpp)
target_link_libraries(motion_streaming_interface 
  industrial_robot_client 
  simple_message
  ${catkin_LIBRARIES})

add_executable(motion_download_interface
  src/generic_joint_downloader_node.cpp)
target_link_libraries(motion_download_interface 
  industrial_robot_client 
  simple_message
  ${catkin_LIBRARIES})

# The following executables(nodes) are for applications where the robot
# controller and pc have different same byte order (i.e. byte swapping IS
# required)

add_executable(robot_state_bswap
  src/generic_robot_state_node.cpp)
target_link_libraries(robot_state_bswap 
  industrial_robot_client_bswap 
  simple_message_bswap
  ${catkin_LIBRARIES})

add_executable(motion_streaming_interface_bswap
  src/generic_joint_streamer_node.cpp)
target_link_libraries(motion_streaming_interface_bswap 
  industrial_robot_client_bswap  
  simple_message_bswap
  ${catkin_LIBRARIES})

add_executable(motion_download_interface_bswap
  src/generic_joint_downloader_node.cpp)
target_link_libraries(motion_download_interface_bswap 
  industrial_robot_client_bswap  
  simple_message_bswap
  ${catkin_LIBRARIES})

# The following executables(nodes) interface with the robot controller
# at a higher level so there is no need to create two versions (one with
# byte swapping, one without)

add_executable(joint_trajectory_action 
  src/generic_joint_trajectory_action_node.cpp
  src/joint_trajectory_action.cpp)
target_link_libraries(joint_trajectory_action 
  industrial_robot_client ${catkin_LIBRARIES})

##########
## Test ##
##########
# Testing - Only performed on normal (non byte swapped library)
if (CATKIN_ENABLE_TESTING)
  catkin_add_gtest(utest_robot_client test/utest.cpp)
  target_link_libraries(utest_robot_client
    industrial_robot_client
    ${catkin_LIBRARIES})
endif()

if (CATKIN_ENABLE_TESTING)
  find_package(roslaunch REQUIRED)
  roslaunch_add_file_check(test/roslaunch_test.xml)
endif()

# ROS launch testing
## ROS launch test should be enabled when launch parameters are supported,
## see details below:
## robot_interface_streaming.launch: 'robot_ip'
## robot_state_visualize.launch]: 'urdf_path'
## robot_interface_download.launch]: 'robot_ip'
##find_package(roslaunch)
##roslaunch_add_file_check(launch)

install(
    TARGETS industrial_robot_client industrial_robot_client_bswap
    ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
    LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
    RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION})

install(TARGETS 
        robot_state 
        robot_state_bswap 
        motion_streaming_interface 
        motion_download_interface 
        motion_streaming_interface_bswap 
        motion_download_interface_bswap 
        joint_trajectory_action 
    RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})

install(
    DIRECTORY include/${PROJECT_NAME}/
    DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})

foreach(dir config launch)
   install(DIRECTORY ${dir}/
      DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/${dir})
endforeach(dir)

=== debian/changelog ===
ros-kinetic-industrial-robot-client (0.7.1-1xenial) xenial; urgency=high

  * Updated all package xml files to version 2 (#232 <https://github.com/ros-industrial/industrial_core/issues/232>)
  * all: update maintainer email addresses (#222 <https://github.com/ros-industrial/industrial_core/issues/222>)
  * Add namespacing to all ``joint_trajectory_action`` log messages (#192 <https://github.com/ros-industrial/industrial_core/issues/192>)
  * Correct off-by-one on debug output (#229 <https://github.com/ros-industrial/industrial_core/issues/229>)
  * Contributors: Dave Coleman, Gonzalo Casas, Jeremy Zoss, Jorge Nicho, gavanderhoorn

 -- Shaun Edwards <shaun.edwards@gmail.com>  Wed, 18 Sep 2019 22:00:00 -0000

ros-kinetic-industrial-robot-client (0.7.0-1xenial) xenial; urgency=high

  * Decrease idle wait time.  250 ms is too slow. Fix #214 <https://github.com/ros-industrial/industrial_core/issues/214>.
  * robot_client: add roslaunch testing. Fix #208 <https://github.com/ros-industrial/industrial_core/issues/208>.
  * Removed robot_state_visualization.launch, as that would introduce a dependency on rviz. Fix ros-industrial/ros_industrial_issues#50 <https://github.com/ros-industrial/ros_industrial_issues/issues/50>.
  * robot_client: add missing dependency on RSP. Fix #209 <https://github.com/ros-industrial/industrial_core/issues/209>.
  * Updated the libraries install tags- follow the official documentation. Fix #193 <https://github.com/ros-industrial/industrial_core/issues/193>.
  * Added missed test dependencies to rosunit. Fix #205 <https://github.com/ros-industrial/industrial_core/issues/205>.
  * Using the 'doc' attribute on 'arg' elements. Added doc strings to all launch file args.
  * Merge branch 'kinetic-devel' into urdfdom_headers_fix
  * robot_client: make indenting consistent.
  * client: build unit tests conditionally
  * Contributors: Dmitry Rozhkov, G.A. vd. Hoorn, Harsh Deshpande, Levi Armstrong, Nadia Hammoudeh García, Patrick Beeson, Shaun Edwards, gavanderhoorn

 -- Shaun Edwards <sedwards@swri.org>  Mon, 11 Feb 2019 23:00:00 -0000

ros-kinetic-industrial-robot-client (0.6.0-1xenial) xenial; urgency=high

  * Added C++ 11 compile option
  * Contributors: Victor Lamoine

 -- Shaun Edwards <sedwards@swri.org>  Sun, 15 Jan 2017 23:00:00 -0000

ros-kinetic-industrial-robot-client (0.5.1-1xenial) xenial; urgency=high

  * robot_status: missing reply to SERVICE_REQUEST. Fix in robot_status_message and relay_handler.
  * industrial_robot_client: Fix signature of goal and cancel callbacks.
  * Contributors: Alberto Marini, Maarten de Vries

 -- Shaun Edwards <sedwards@swri.org>  Sat, 14 Jan 2017 23:00:00 -0000

ros-kinetic-industrial-robot-client (0.5.0-1xenial) xenial; urgency=high

  * Start checking for trajectory completion as soon as the first moving status arrives
  * Forces the action to wait for half of the duration of the trajectory
    before it begins to check for completition. This prevents the action
    for returning immediately for trajectories that end near the start
    point and are slow to start moving.
  * Merge pull request #115 <https://github.com/shaun-edwards/industrial_core/issues/115> from Jmeyer1292/issue#114 <https://github.com/Jmeyer1292/issue/issues/114>`__start_tolerance_check Issue`#114 <https://github.com/shaun-edwards/industrial_core/issues/114> - Action Server withinGoalConstraints check removal
  * Revert "Revert "Merge pull request #113 <https://github.com/shaun-edwards/industrial_core/issues/113> from simonschmeisser/indigo""
    This reverts commit fb28e26fdbd3c316941d4d66af2f1c9b5410cb0d.
  * Removed withinTolerance check from the accept function
  * Contributors: Jonathan Meyer, Shaun Edwards, Simon Schmeisser

 -- Shaun Edwards <sedwards@swri.org>  Sun, 21 Feb 2016 23:00:00 -0000

ros-kinetic-industrial-robot-client (0.4.3-1xenial) xenial; urgency=high

  * Start checking for trajectory completion as soon as the first moving status arrives
  * Contributors: Simon Schmeisser

 -- Shaun Edwards <sedwards@swri.org>  Sat, 06 Feb 2016 23:00:00 -0000

ros-kinetic-industrial-robot-client (0.4.2-1xenial) xenial; urgency=high

  * Forces the action to wait for half of the duration of the trajectory
    before it begins to check for completition. This prevents the action
    for returning immediately for trajectories that end near the start
    point and are slow to start moving.
  * Fix rejected actions when goal requests arrive in between watchdog reset und arrival of next status package
  * Contributors: Jonathan Meyer, Shaun Edwards, Simon Schmeisser (isys vision)

 -- Shaun Edwards <sedwards@swri.org>  Tue, 20 Oct 2015 22:00:00 -0000

ros-kinetic-industrial-robot-client (0.4.1-1xenial) xenial; urgency=high

  * Fixed changelog links to point to main repo
  * Contributors: Shaun Edwards

 -- Shaun Edwards <sedwards@swri.org>  Sun, 22 Mar 2015 23:00:00 -0000

ros-kinetic-industrial-robot-client (0.4.0-1xenial) xenial; urgency=high

  * Fill stamp of the RobotStatus message Fix: #97 <https://github.com/ros-industrial/industrial_core/issues/97>
    Just edited on a github didn't test it.
  * Only accept goals after reception of controller feedback. Fix #85 <https://github.com/ros-industrial/industrial_core/issues/85>.
  * robot_client: workaround for #46 <https://github.com/ros-industrial/industrial_core/issues/46>. Fix #67 <https://github.com/ros-industrial/industrial_core/issues/67>.
    This is an updated version of the workaround committed in 9df46977. Instead
    of requiring dependent packages to invoke the function defined in the
    CFG_EXTRAS cmake snippet, the snippet now sets up the linker path directly.
    Dependent packages now only need to remember to explicitly list their
    dependency on industrial_robot_client and simple_message in their
    add_library(..) statements.
  * Contributors: Libor Wagner, gavanderhoorn

 -- Shaun Edwards <sedwards@swri.org>  Fri, 20 Mar 2015 23:00:00 -0000



=== debian/control ===
Source: ros-kinetic-industrial-robot-client
Section: misc
Priority: extra
Maintainer: Shaun Edwards <shaun.edwards@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-kinetic-actionlib, ros-kinetic-actionlib-msgs, ros-kinetic-catkin, ros-kinetic-control-msgs, ros-kinetic-industrial-msgs, ros-kinetic-industrial-utils, ros-kinetic-roscpp, ros-kinetic-rosunit, ros-kinetic-sensor-msgs, ros-kinetic-simple-message, ros-kinetic-std-msgs, ros-kinetic-trajectory-msgs, ros-kinetic-urdf
Homepage: http://ros.org/wiki/industrial_robot_client
Standards-Version: 3.9.2

Package: ros-kinetic-industrial-robot-client
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-kinetic-actionlib, ros-kinetic-actionlib-msgs, ros-kinetic-control-msgs, ros-kinetic-industrial-msgs, ros-kinetic-industrial-utils, ros-kinetic-robot-state-publisher, ros-kinetic-roscpp, ros-kinetic-sensor-msgs, ros-kinetic-simple-message, ros-kinetic-std-msgs, ros-kinetic-trajectory-msgs, ros-kinetic-urdf
Description: industrial robot client contains generic clients for connecting to industrial robot controllers with servers that adhere to the simple message protocol.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-industrial-robot-client//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
